#ifndef _FTDIPSI_H_
#define _FTDIPSI_H_ 1

#include <libusb.h>

struct ftdispi_s;

struct ftdispi_s *ftdispi_new(libusb_context *ctx,
			      uint16_t vendor_id, uint16_t product_id,
			      int mode,
			      int cs_delay,
			      int cs_high,
			      int *pret);

void ftdispi_delete(struct ftdispi_s *dev);

int ftdispi_spi(struct ftdispi_s *dev,
		uint8_t  *data_out,
		int n_out,
		uint8_t  *data_in,
		int n_in);

int ftdispi_gpio_conf(struct ftdispi_s *dev,
		      int gpio, int dir, int val);

int ftdispi_gpio_set(struct ftdispi_s *dev,
		     int gpio, int val);

int ftdispi_gpio_get(struct ftdispi_s *dev,
		     int gpio);

int ftdispi_loop(struct ftdispi_s *dev, int on);

int ftdispi_freq(struct ftdispi_s *dev, unsigned long hz);

#define FTDI_SPI_GPIOL0 0x10
#define FTDI_SPI_GPIOL1 0x11
#define FTDI_SPI_GPIOL2 0x12
#define FTDI_SPI_GPIOL3 0x13

#define FTDI_SPI_GPIOH0 0
#define FTDI_SPI_GPIOH1 1
#define FTDI_SPI_GPIOH2 2
#define FTDI_SPI_GPIOH3 3
#define FTDI_SPI_GPIOH4 4
#define FTDI_SPI_GPIOH5 5
#define FTDI_SPI_GPIOH6 6
#define FTDI_SPI_GPIOH7 7

#endif
